import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import javax.swing.*;

public class Main implements KeyListener, Runnable {

private static JFrame window;
private static Graphics2D display;

private static int frmRate = 15;
private static final int WIDTH = 512;		//Viewable width
private static final int HEIGHT = 448;	//Viewable height
private static int cX = WIDTH/2 - 16;		//Adjusted Center for Sprites
private static int cY = HEIGHT/2 - 24;	//
private static int X, Y;								//(0,0) coords relative to Insets

private static Thread thread;
private static Main MAIN;
private static Graphics G;
private static BufferedImage IMG;

static int 			 GAMESTATE = 1;			//Current state
static final int FADE = -1;					//Game states
static final int START_MENU = 0;		//
static final int GAME_RUNNING = 1;	//
static final int GAME_MENU = 2;			//

static Sprite cSprite;					//Current Sprite
static int C = 0;								//current Character
static int c = 1; 							//current Map
static int alpha = 0;						//fade
static int ticks = 0;
private static boolean faded = false;

static boolean running = true;
static boolean loading = true;
static long fpsStart = 0;
static int fpsDiff, FPS = 0;

static boolean key[] = new boolean[123];
static boolean keyP[] = new boolean[123];
static Vector maps = new Vector();
static Map[] map = new Map[7];

//TEMPORARY------------------------

static Font font;
static Menu test;
static boolean menuTest = false;
static String foob[] = {"Talk to","Goods","PSI","Equip","Check","Status"};

//---------------------------------

public Main() {}

public Main(String title) {

	window = new JFrame(title);
	//window.setUndecorated(true);
	window.setResizable(false);

	Insets I = window.getInsets();
	window.setSize(WIDTH + I.left + I.right,HEIGHT + I.top + I.bottom);
	X = I.left;
	Y = I.top;

	IMG = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_INT_RGB);
	G = IMG.getGraphics();

	window.addKeyListener(this);
	window.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent w) {
			close();
		}
	});

	window.setVisible(true);
	display = (Graphics2D) window.getContentPane().getGraphics();

} //Main

public static void main(String [] args) {

	MAIN = new Main("Earthbound Something");

	thread = new Thread(MAIN);
	thread.start();

}//main

public void run() {

	for(c=3;c>0;c--) {
		map[c] = new Map(c);
		map[c].buildMap();
	}
	c++;
	cSprite = map[c].getS(C);

	loading = false;

  font = new Font(Font.STYLE_NORMAL);

  Window.init();
  test = new Menu(7,4,2,3,96,foob);

	while(running) {
	ticks++;
	if(ticks>100)ticks=0;
	switch(GAMESTATE){
	case FADE:
		map[c].updateMap();
		update();
	break;//FADE

	case GAME_RUNNING:
		checkInput();
		map[c].checkSprites();
		map[c].updateMap();
		update();


		FPS++;
		if((System.currentTimeMillis() - fpsStart) >= 1000) {
			window.setTitle("Earthbound Something - " + FPS + " fps");
			FPS = 0;
			fpsStart = System.currentTimeMillis();
		}
	break;//GAME_RUNNING

	case GAME_MENU:
		checkInput();
		update();

	break;//GAME_MENU
	}
	pause(frmRate);
	}
}//run

public static void useGate(Gateway gate, Vector s){
	gate.trigger(s);
	c = gate.getIndex();
	map[c].loadSprites(gate.getSprites());
	GAMESTATE = FADE;
}//useGate

public static void switchChar(int index) {
	C = index;
	cSprite = map[c].getS(C);
}//switchChar

public static void update() {
if(loading){}else{

switch(GAMESTATE) {
	case FADE:
		if(alpha<=255 && !faded) {
			G.setColor(new Color(0,0,0,alpha));
			G.fillRect(0,0,WIDTH,HEIGHT);
			alpha += 20;
		}
		else {
			if(!faded)
			faded = true;
			alpha -= 20;
			G.drawImage(map[c].getMap(),cX - map[c].getSX(C),cY - map[c].getSY(C),null);
			G.setColor(new Color(0,0,0,alpha));
			G.fillRect(0,0,WIDTH,HEIGHT);
			if(alpha<=0) {
				GAMESTATE = 1;
				faded = false;
			}
		}
	break;//FADE

  case GAME_RUNNING:
		G.setColor(Color.BLACK);
		G.fillRect(0,0,WIDTH,HEIGHT);
		G.drawImage(map[c].getMap(),cX - map[c].getSX(C),cY - map[c].getSY(C),null);
	break;//GAME_RUNNING

  case GAME_MENU:
		G.setColor(Color.BLACK);
		G.fillRect(0,0,WIDTH,HEIGHT);
		G.drawImage(map[c].getMap(),cX - map[c].getSX(C),cY - map[c].getSY(C),null);
		G.drawImage(test.display(),X+test.getX(),Y+test.getY(),null);
		G.drawImage(Window.check[1-(int)((ticks%20)/10)],X+test.getCheckX(),Y+test.getCheckY(),null);

	break;
}
display.drawImage(IMG,X,Y,null);

}}//paint

public void checkInput() {
if(key[KeyEvent.VK_ESCAPE]) close();
switch(GAMESTATE) {
	case GAME_RUNNING:
	//Misc Keys
		if(key[KeyEvent.VK_A])	switchChar(0);
		if(key[KeyEvent.VK_S])	switchChar(1);
		if(key[KeyEvent.VK_D])	switchChar(2);
		if(key[KeyEvent.VK_F])	switchChar(3);

		if(key[KeyEvent.VK_Q])	GAMESTATE = GAME_MENU;
		if(key[KeyEvent.VK_E])	frmRate++;
		if(key[KeyEvent.VK_R])	if(frmRate!=0) frmRate--;

	//Movement
		if(key[KeyEvent.VK_UP]){
			cSprite.setDir(1,true);
			cSprite.setDir(0,false);
		}
		else cSprite.setDir(1,false);

		if(key[KeyEvent.VK_DOWN]){
			cSprite.setDir(0,true);
			cSprite.setDir(1,false);
		}
		else cSprite.setDir(0,false);

		if(key[KeyEvent.VK_LEFT]){
			cSprite.setDir(2,true);
			cSprite.setDir(3,false);
		}
		else cSprite.setDir(2,false);

		if(key[KeyEvent.VK_RIGHT]){
			cSprite.setDir(3,true);
			cSprite.setDir(2,false);
		}
		else cSprite.setDir(3,false);
	break;//GAME_RUNNING

	case GAME_MENU:
		if(key[KeyEvent.VK_W])	GAMESTATE = GAME_RUNNING;
		if(key[KeyEvent.VK_RIGHT])
			if(!keyP[KeyEvent.VK_RIGHT]) {
				test.shiftR();
				keyP[KeyEvent.VK_RIGHT] = true;
		 	}
		if(key[KeyEvent.VK_LEFT])
			if(!keyP[KeyEvent.VK_LEFT]) {
				test.shiftL();
				keyP[KeyEvent.VK_LEFT] = true;
			}
		if(key[KeyEvent.VK_UP])
			if(!keyP[KeyEvent.VK_UP]) {
				test.shiftU();
			  keyP[KeyEvent.VK_UP] = true;
			}
		if(key[KeyEvent.VK_DOWN])
			if(!keyP[KeyEvent.VK_DOWN]) {
				test.shiftD();
				keyP[KeyEvent.VK_DOWN] = true;
			}
	break;//GAME_MENU
}
}//checkInput

public void keyPressed(KeyEvent evt) {
	key[evt.getKeyCode()] = true;
}//keyPressed

public void keyReleased(KeyEvent evt) {
	key[evt.getKeyCode()] = false;
	keyP[evt.getKeyCode()] = false;
}//keyReleased

public void keyTyped(KeyEvent evt) {}//keyTyped

public void pause(int time) {
	try { Thread.sleep(time); }
	catch (InterruptedException e) {}
}//pause

public void close() {
	running = false;
	System.exit(0);
}//close



}//Main