import java.util.*;
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class Sprite{

final static double dR = 0.8;
int index;
int x,y,w,h;
int bX,bY,bW,bH;
int pX = 0,
		pY = 0;
int spd;
int direction;
int ticks = 0;
int tickRate = 10;
boolean[] d = new boolean[8];

int numFrames;
int F = 14;
Image frame[];

Rectangle box;

public Sprite() {}

public Sprite(int index,int x,int y) {
	this.index = index;
	this.x = x;
	this.y = y;
	loadSprite(index);
	buildSprite(index);

}

public Sprite copy() {
	return new Sprite(index,x,y);
}

public void loadSprite(int index) {

		StringTokenizer tokens; //File input variables
		String inFileName;			//
		InputStreamReader inStream;		//
		BufferedReader in;			//
		String fileLine;				//

		try {
			inStream = new InputStreamReader(ClassLoader.getSystemResource("Chars/"+(Integer.toString(index) + "c.tls")).openStream());
			in = new BufferedReader(inStream);
			fileLine = in.readLine();
			tokens = new StringTokenizer(fileLine);

			//Number of frames
			numFrames = Integer.parseInt(tokens.nextToken());

			//Dimensions of Sprite
			fileLine = in.readLine();
			tokens = new StringTokenizer(fileLine);
			w = Integer.parseInt(tokens.nextToken());
			h = Integer.parseInt(tokens.nextToken());

			fileLine = in.readLine();
			tokens = new StringTokenizer(fileLine);
		 	bX = Integer.parseInt(tokens.nextToken());
		 	bY = Integer.parseInt(tokens.nextToken());

		 	fileLine = in.readLine();
			tokens = new StringTokenizer(fileLine);
		 	bW = Integer.parseInt(tokens.nextToken());
		 	bH = Integer.parseInt(tokens.nextToken());

			in.close();
		}
		catch (IOException e) {
			System.out.println(e.getMessage());
	}

	box = new Rectangle(x+bX,y+bY,bW,bH);
	spd = 4;
	direction = 1;
}

public void buildSprite(int index) {
	ImageIcon img;
	Image frames;
	Graphics g;

	frame = new Image[numFrames];
	img = new ImageIcon(ClassLoader.getSystemResource("Chars/"+index + "c.tlr"));
	frames = img.getImage();

	for (int i=0; i<numFrames; i++) {
		frame[i] = new BufferedImage(w,h, BufferedImage.TYPE_INT_RGB);
		g = frame[i].getGraphics();
		g.drawImage(
			frames,
			0,0,w,h,
			(1*(i+1))+(w*i),0,
			(1*(i+1))+(w*i)+w,h,
			null);
		frame[i] = new Label().createImage(
			new FilteredImageSource(frame[i].getSource(),
			new filterMask()));
	}

}

public void check() {
	if(d[0]){
		if(d[2]){ move(5); }
		else{
		if(d[3]){ move(6); }
		else{			move(1); }}}
	else {
	if(d[1]){
		if(d[2]){ move(7); }
		else{
		if(d[3]){ move(8); }
		else{			move(2); }}}
	else {
		if(d[2]){ move(3); }
		else {
		if(d[3]){ move(4); }
		else    { ticks = 0;}}}
	}
}

public void move(int dir) {
	ticks++;
	direction = dir;
	switch (dir) {
		case 1:	//down
			setLoc(getBX(),getBY()+spd);
			break;
		case 2: //up
			setLoc(getBX(),getBY()-spd);
			break;
		case 3: //left
			setLoc(getBX()-spd,getBY());
			break;
		case 4: //right
			setLoc(getBX()+spd,getBY());
			break;
		case 5: //down-left
			setLoc(getBX()-(int)(spd*dR),getBY()+(int)(spd*dR));
			break;
		case 6: //down-right
			setLoc(getBX()+(int)(spd*dR),getBY()+(int)(spd*dR));
			break;
		case 7: //up-left
			setLoc(getBX()-(int)(spd*dR),getBY()-(int)(spd*dR));
			break;
		case 8: //up-right
			setLoc(getBX()+(int)(spd*dR),getBY()-(int)(spd*dR));
			break;
	}

}

public void setLoc(int nX,int nY) {
	pX = x + bX;
	pY = y + bY;
	x = nX - bX;
	y = nY - bY;
	setBox(x,y);
}

public void setBox(int nX, int nY) {
	box.setLocation(nX+bX,nY+bY);
}

public void checkTicks() {
	if(ticks > tickRate)
		F = direction + 7;
	else
		F = direction - 1;
	if(ticks > ((tickRate*2)-1))
		ticks = 0;
}

public void setDir(int dir, boolean b) {
	d[dir] = b;
}

public void setDirection(int newDir) {
	direction = newDir;
}

public final Image frame() {
	checkTicks();
	return frame[F];
}

public final Rectangle getBox() {
	return box;
}

public final int getDir() {
	return direction;
}

public final int getX() {
	return x;
}

public final int getY() {
	return y;
}

public final int getW() {
	return w;
}

public final int getH() {
	return h;
}

public final int getBX() {
	return x+bX;
}

public final int getBY() {
	return y+bY;
}

public final int getBW() {
	return bW;
}

public final int getBH() {
	return bH;
}

public final int getSpd() {
	return spd;
}

public final double getdR() {
	return dR;
}

}//Sprite